Bug 1417385 - FTBFS with GCC-7 on PPC64LE
Summary: FTBFS with GCC-7 on PPC64LE
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: openblas
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Susi Lehtola
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/xianyi/OpenBLAS/is...
Whiteboard:
: 1419489 1421710 (view as bug list)
Depends On:
Blocks: 1418471 1423089 1423094 1423097 1423258 1423528 1423581 1423618 1423695 1423851 1423920 1423998 1424105 1424439 1424443
TreeView+ depends on / blocked
 
Reported: 2017-01-28 15:39 UTC by Björn 'besser82' Esser
Modified: 2017-03-02 06:27 UTC (History)
12 users (show)

Fixed In Version: openblas-0.2.19-7.fc26
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-02-13 22:20:03 UTC
Type: Bug


Attachments (Terms of Use)
build.log on PPC64LE (679.50 KB, text/plain)
2017-01-28 15:39 UTC, Björn 'besser82' Esser
no flags Details


Links
System ID Private Priority Status Summary Last Updated
GNU Compiler Collection 79343 0 None None None 2017-02-02 14:29:19 UTC

Description Björn 'besser82' Esser 2017-01-28 15:39:08 UTC
Created attachment 1245409 [details]
build.log on PPC64LE

Description of problem:

  FTBFS with GCC-7 on PPC64LE.  See attached build.log.


How reproducible:

  100%


Steps to Reproduce:

  1.  Rebuild for libgfortran on GCC-7.
  2.  Build fails on PPC64LE


Actual results:

  Build fails with `error: PIC register clobbered by '%2' in 'asm'`.


Expected results:

  Build succeds as expected.

Comment 1 Björn 'besser82' Esser 2017-02-01 17:53:36 UTC
@jakub:  Or might that be another PPC64LE bug in GCC-7?

Comment 2 Jakub Jelinek 2017-02-01 17:55:33 UTC
Can you attach preprocessed source that reproduces it?

Comment 3 Björn 'besser82' Esser 2017-02-01 18:05:07 UTC
Unfortunately not, since I don't own any PPC64LE metal…  That error can be reproduced building openblas in Rawhide on Koji.

This is last build, I made:  https://koji.fedoraproject.org/koji/taskinfo?taskID=17540767

Hope, that helps you.

Comment 4 Jakub Jelinek 2017-02-02 14:29:20 UTC
Filed as GCC PR79343, we'll see if it is openblas bug or gcc bug.

Comment 5 Jakub Jelinek 2017-02-02 14:30:43 UTC
So openblas bug, see http://gcc.gnu.org/gcc-7/changes.html for details.

Comment 6 Björn 'besser82' Esser 2017-02-03 23:46:56 UTC
Added upstream issue in URL-field…

Comment 7 Dominik 'Rathann' Mierzejewski 2017-02-06 09:15:28 UTC
This is blocking scalapack->elpa->cp2k for me (I maintain the last two). I have a ppc64le VM if anyone wants to debug on the actual hardware.

Comment 8 Susi Lehtola 2017-02-06 21:02:55 UTC
*** Bug 1419489 has been marked as a duplicate of this bug. ***

Comment 9 Tom "spot" Callaway 2017-02-07 14:26:03 UTC
Could we possibly ExcludeArch ppc64 until this is resolved?

Comment 10 Jakub Jelinek 2017-02-08 13:04:07 UTC
Or disable use of inline asm for ppc64 until then (if there is any fallback C/Fortran code).

Comment 11 Björn 'besser82' Esser 2017-02-08 14:27:30 UTC
Alan Modra from IBM is already working on fixing the inline asm for power-8

Comment 12 Ralf Corsepius 2017-02-08 15:23:42 UTC
(In reply to Björn "besser82" Esser from comment #11)
> Alan Modra from IBM is already working on fixing the inline asm for power-8
When can a solution to the blockade openblas causes be expected? 

IMHO, should this bug not be fixed by the end of this week, I'm with Spot and am leaning towards ExcludeArch'ing the ppc64le for openblas or to request to drop the ppc64le from Fedora's distros, due to lack of toolchain usability.

Comment 13 Jakub Jelinek 2017-02-08 15:28:49 UTC
(In reply to Ralf Corsepius from comment #12)
> request to drop the ppc64le from Fedora's distros, due to lack of toolchain
> usability.

This is openblas package bug, so why do you talk about toolchain usability?  It worked by accident in the past, has been buggy since the inline asm has been added for power8.

Comment 14 Tom Hughes 2017-02-08 15:36:55 UTC
ExcludeArch won't really help unless we also apply it to everything that depends (directly or indirectly) on openblas, and I fear that it quite a large set of packages.

Comment 15 Ralf Corsepius 2017-02-08 16:09:04 UTC
(In reply to Jakub Jelinek from comment #13)
> (In reply to Ralf Corsepius from comment #12)
> > request to drop the ppc64le from Fedora's distros, due to lack of toolchain
> > usability.
> 
> This is openblas package bug, so why do you talk about toolchain usability? 
> It worked by accident in the past, has been buggy since the inline asm has
> been added for power8.
The ppc64le had not been a fedora-supported architecture.

=> This now has impacts on all fedora architectures, which qualifies as an overall regression to Fedora, IMHO.


(In reply to Tom Hughes from comment #14)
> ExcludeArch won't really help unless we also apply it to everything that
> depends (directly or indirectly) on openblas, and I fear that it quite a
> large set of packages.
Correct. One would have implement some rpm-macros to have all deps of this package excluded. IIRC, some qt-packages already are doing this, unless I am mistake also because of the ppc64le.

Comment 16 Ralf Corsepius 2017-02-08 17:14:25 UTC
(In reply to Ralf Corsepius from comment #15)
> IIRC, some qt-packages already are doing this, unless I am
> mistake also because of the ppc64le.

Just found it - It's qtwebengine, which does not seem to support the ppc64* at all. 

The Fedora-qt-folks apparently resorted to implement a %qt5_qtwebengine_arches
macro in /usr/lib/rpm/macros.d/macros.qt5-srpm provided through package qt5-srpm-macros, all qt5-webengine using packages are supposed to Require.

c.f. https://bugzilla.redhat.com/show_bug.cgi?id=1298011

Delicate about this is, that qtwebengines is the designated replacement the notoriously vulnerable qtwebkit* variants. This means we like have to retire applications from the ppc64* soon.

Comment 17 Björn 'besser82' Esser 2017-02-09 08:41:35 UTC
There is progress going on upstream:  https://github.com/xianyi/OpenBLAS/issues/1078#issuecomment-278542809


It looks there will be a patch (or a new release, maybe) solving this issue pretty soon.

Comment 18 Björn 'besser82' Esser 2017-02-13 22:17:51 UTC
*** Bug 1421710 has been marked as a duplicate of this bug. ***

Comment 19 Björn 'besser82' Esser 2017-02-13 22:20:03 UTC
Just applied the fixing patch.  Build should be finished soon.

Comment 20 Dominik 'Rathann' Mierzejewski 2017-02-13 23:31:07 UTC
Thanks, rebuilding scalapack now.

Comment 21 Jaroslav Škarvada 2017-02-14 13:20:48 UTC
Thanks HPL rebuilt OK.

Comment 22 Ralf Corsepius 2017-02-14 13:57:52 UTC
freefem++ and OpenSceneGraph rebuilt.


Note You need to log in before you can comment on or make changes to this bug.